import React from "react";
import { connect } from "react-redux";
import { compose } from "recompose";

// import AuthUserContext from "./context";
import { withFirebase } from "../Firebase";
import * as ACTIONS from "../../constants/actions";

const withAuthentication = Component => {
  class WithAuthentication extends React.Component {
    constructor(props) {
      super(props);

      this.props.onSetAuthUser(
        JSON.parse(localStorage.getItem("avvy:authUser"))
      );
    }

    componentDidMount() {
      this.listener = this.props.firebase.onAuthUserListener(
        authUser => {
          this.props.onSetAuthUser(authUser);
        },
        () => {
          this.props.onSetAuthUser(null);
        }
      );
    }

    componentWillUnmount() {
      this.listener();
    }

    render() {
      return <Component {...this.props} />;
    }
  }

  const mapDispatchToProps = dispatch => ({
    onSetAuthUser: authUser => {
      localStorage.setItem("avvy:authUser", JSON.stringify(authUser));
      dispatch({ type: ACTIONS.USER.AUTH_USER_SET, authUser });
    }
  });

  return compose(
    withFirebase,
    connect(
      null,
      mapDispatchToProps
    )
  )(WithAuthentication);
};

export default withAuthentication;
