import React from "react";
import uuidv1 from "uuid/v1";
import { withFirebase } from "../Firebase";

import { Carousel } from "react-responsive-carousel";
import "react-responsive-carousel/lib/styles/carousel.min.css";

class StructureView extends React.Component {
  constructor(props) {
    super(props);

    this.state = {
      urls: []
    };
  }

  componentDidMount() {
    const { firebase, uid } = this.props;
    firebase.getStorageList(`screenshots/${uid}`).then(result => {
      Promise.all(result.items.map(item => item.getDownloadURL())).then(
        urls => {
          this.setState({ urls });
        }
      );
    });
  }

  render() {
    const { urls } = this.state;
    const slides = urls.map(url => <img key={uuidv1()} src={url} alt="" />);
    return (
      <Carousel showThumbs={false} infiniteLoop={true} width={"100%"}>
        {slides}
      </Carousel>
    );
  }
}

export default withFirebase(StructureView);
