import React from "react";
import ReactDOM from "react-dom";
import { Provider } from "react-redux";

import store from "./store/configureStore";
import "./index.scss";
import * as serviceWorker from "./serviceWorker";

import App from "./containers/App";
import Firebase, { FirebaseContext } from "./components/Firebase";

import "semantic-ui-css/semantic.min.css";

ReactDOM.render(
  <Provider store={store}>
    <FirebaseContext.Provider value={new Firebase()}>
      <App />
    </FirebaseContext.Provider>
  </Provider>,
  document.getElementById("root")
);

serviceWorker.unregister();
